unit UnidadFormMenuPrincipal;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, BufDataset,
  FileUtil, Forms, Controls, Graphics,
  Dialogs, StdCtrls, DBGrids, DbCtrls, ZConnection, ZDataset, inifiles, lclintf;

type

  { TformPrincipal }

  TformPrincipal = class(TForm)
    btEjecutar: TButton;
    btConectar: TButton;
    Label7: TLabel;
    lsProtocolo: TComboBox;
    dbNavegador: TDBNavigator;
    dbTabla: TDatasource;
    Label5: TLabel;
    Label6: TLabel;
    opModificacion: TCheckBox;
    gridBD: TDBGrid;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    txtContrasena: TEdit;
    txtBD: TEdit;
    txtPuerto: TEdit;
    txtServidor: TEdit;
    txtSQL: TMemo;
    txtUsuario: TEdit;
    bdConexion: TZConnection;
    tConsultaSQL: TZQuery;
    procedure btConectarClick(Sender: TObject);
    procedure btEjecutarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Label7Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  formPrincipal: TformPrincipal;

implementation

{$R *.lfm}

{ TformPrincipal }

procedure TformPrincipal.btConectarClick(Sender: TObject);
begin
  try
    bdConexion.Connected := false;
    bdConexion.HostName := txtServidor.Text;
    bdConexion.Password := txtContrasena.Text;
    bdConexion.Port := StrToInt(txtPuerto.Text);
    bdConexion.User := txtUsuario.Text;
    bdConexion.Database := txtBD.Text;
    bdConexion.Catalog := txtBD.Text;
    bdConexion.Protocol:= lsProtocolo.Text;
    bdConexion.Connected := true;
    MessageDlg ('Conexión realizada correctamente al ' +
        'servidor de base de datos.', mtInformation, [mbOK], 0);
    txtSQL.SetFocus;
  except
    raise;
  end;
end;

procedure TformPrincipal.btEjecutarClick(Sender: TObject);
begin
  tConsultaSQL.Close;
  tConsultaSQL.SQL.Clear;
  tConsultaSQL.SQL.Add(txtSQL.Text);
  try
    if opModificacion.Checked then
      tConsultaSQL.ExecSQL
    else
      tConsultaSQL.Open;
  except
    raise;
  end;
end;

procedure TformPrincipal.FormClose(Sender: TObject;  var CloseAction: TCloseAction);
var
  fichero : string;
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    writeBool ('SQL', 'Modificación', opModificacion.Checked);
    writeInteger ('Conexión Base Datos', 'Puerto', StrToInt(txtPuerto.Text));
    writeString ('Conexión Base Datos', 'Servidor', txtServidor.Text);
    writeString ('Conexión Base Datos', 'Usuario', txtUsuario.Text);
    writeString ('Conexión Base Datos', 'Base datos', txtBD.Text);
    writeString ('Conexión Base Datos', 'Protocolo', lsProtocolo.Text);
    writeString ('Conexión Base Datos', 'Contraseña', txtContrasena.Text);
  finally
    free;
  end;
  fichero := IncludeTrailingPathDelimiter(ExtractFilePath(paramstr(0))) +
      'ultimasqlejecutada.sql';
  txtSQL.Lines.SaveToFile(fichero);
end;

procedure TformPrincipal.FormCreate(Sender: TObject);
var
  fichero : string;
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    opModificacion.Checked := ReadBool ('SQL', 'Modificación', false);
    txtPuerto.Text := IntToStr(ReadInteger ('Conexión Base Datos', 'Puerto', 5433));
    txtServidor.Text := ReadString ('Conexión Base Datos', 'Servidor', 'localhost');
    txtUsuario.Text := ReadString ('Conexión Base Datos', 'Usuario', '');
    txtBD.Text := ReadString ('Conexión Base Datos', 'Base datos', '');
    lsProtocolo.Text := ReadString ('Conexión Base Datos', 'Protocolo', 'postgresql-9');
    txtContrasena.Text := ReadString ('Conexión Base Datos', 'Contraseña', '');
  finally
    free;
  end;
  fichero := IncludeTrailingPathDelimiter(ExtractFilePath(paramstr(0))) +
      'ultimasqlejecutada.sql';
  if FileExists(fichero) then
    txtSQL.Lines.LoadFromFile(fichero);
end;

procedure TformPrincipal.Label7Click(Sender: TObject);
begin
  OpenURL('http://www.ajpdsoft.com');
end;

end.

